/*
 *  OpenGL 3.x Demonstration
 *  
 *  for the "Computergraphics 2" lab
 *
 *  Institute of Computer Graphics and Algorithms
 *  Vienna University of Technology
 *  Vienna, Austria
 *
 *  March 2010
 *
 *  ginquo, vogi, wimmer
 */


#ifndef _OPENGL_3_BASIC_EXAMPLE_
#define _OPENGL_3_BASIC_EXAMPLE_


#include "GLM/glm.hpp"

// sample geometry: surprisingly a cube! :)
// define arrays for vertices, normals, colors and an index-array
static const glm::vec4 vertices[24] =
{
    glm::vec4(-1, -1, -1, 1),
    glm::vec4( 1, -1, -1, 1),
    glm::vec4( 1,  1, -1, 1),
    glm::vec4(-1,  1, -1, 1),

    glm::vec4(-1, -1, -1, 1),
    glm::vec4( 1, -1, -1, 1),
    glm::vec4( 1, -1,  1, 1),
    glm::vec4(-1, -1,  1, 1),

    glm::vec4( 1, -1, -1, 1),
    glm::vec4( 1,  1, -1, 1),
    glm::vec4( 1,  1,  1, 1),
    glm::vec4( 1, -1,  1, 1),

    glm::vec4( 1,  1, -1, 1),
    glm::vec4(-1,  1, -1, 1),
    glm::vec4(-1,  1,  1, 1),
    glm::vec4( 1,  1,  1, 1),

    glm::vec4(-1,  1, -1, 1),
    glm::vec4(-1, -1, -1, 1),
    glm::vec4(-1, -1,  1, 1),
    glm::vec4(-1,  1,  1, 1),

    glm::vec4(-1, -1,  1, 1),
    glm::vec4( 1, -1,  1, 1),
    glm::vec4( 1,  1,  1, 1),
    glm::vec4(-1,  1,  1, 1)
};

static const glm::vec3 normals[24] =
{
    glm::vec3( 0,  0, -1),
    glm::vec3( 0,  0, -1),
    glm::vec3( 0,  0, -1),
    glm::vec3( 0,  0, -1),

    glm::vec3( 0, -1,  0),
    glm::vec3( 0, -1,  0),
    glm::vec3( 0, -1,  0),
    glm::vec3( 0, -1,  0),

    glm::vec3( 1,  0,  0),
    glm::vec3( 1,  0,  0),
    glm::vec3( 1,  0,  0),
    glm::vec3( 1,  0,  0),

    glm::vec3( 0,  1,  0),
    glm::vec3( 0,  1,  0),
    glm::vec3( 0,  1,  0),
    glm::vec3( 0,  1,  0),

    glm::vec3(-1,  0,  0),
    glm::vec3(-1,  0,  0),
    glm::vec3(-1,  0,  0),
    glm::vec3(-1,  0,  0),

    glm::vec3( 0,  0,  1),
    glm::vec3( 0,  0,  1),
    glm::vec3( 0,  0,  1),
    glm::vec3( 0,  0,  1),
};

static const glm::vec4 colors[24] =
{
    glm::vec4(1, 1, 1, 1),
	glm::vec4(1, 1, 1, 1),
	glm::vec4(1, 1, 1, 1),
	glm::vec4(1, 1, 1, 1), 

    glm::vec4(1, 0, 0, 1), 
	glm::vec4(1, 0, 0, 1), 
	glm::vec4(1, 0, 0, 1), 
	glm::vec4(1, 0, 0, 1), 

    glm::vec4(0, 1, 0, 1), 
	glm::vec4(0, 1, 0, 1), 
	glm::vec4(0, 1, 0, 1), 
	glm::vec4(0, 1, 0, 1), 

    glm::vec4(0, 0, 1, 1), 
	glm::vec4(0, 0, 1, 1), 
	glm::vec4(0, 0, 1, 1), 
	glm::vec4(0, 0, 1, 1),

    glm::vec4(1, 1, 0, 1), 
	glm::vec4(1, 1, 0, 1), 
	glm::vec4(1, 1, 0, 1), 
	glm::vec4(1, 1, 0, 1),

    glm::vec4(1, 0.5, 0, 1),
	glm::vec4(1, 0.5, 0, 1),
	glm::vec4(1, 0.5, 0, 1),
	glm::vec4(1, 0.5, 0, 1), 
};

static const int indices[36] =
{
    0, 2, 1, 0, 3, 2,
    4, 5, 6, 4, 6, 7,
    8, 9, 10, 8, 10, 11,
    12, 13, 14, 12, 14, 15,
    16, 17, 18, 16, 18, 19,
    20, 21, 22, 20, 22, 23,
};

#endif
